START TRANSACTION;

ALTER TABLE `tmap` ADD COLUMN `refresh_time` INT UNSIGNED NOT NULL DEFAULT 0;
ALTER TABLE `tplanned_downtime` ADD COLUMN `cron_interval_from` VARCHAR(100) DEFAULT '';
ALTER TABLE `tplanned_downtime` ADD COLUMN `cron_interval_to` VARCHAR(100) DEFAULT '';

ALTER TABLE `tusuario` ADD COLUMN `allowed_ip_active` TINYINT DEFAULT 0;
ALTER TABLE `tusuario` ADD COLUMN `allowed_ip_list` TEXT;

ALTER TABLE `tplugin` ADD COLUMN `no_delete` TINYINT NOT NULL DEFAULT 0;

ALTER TABLE `tmodule_group` MODIFY COLUMN `id_mg` SMALLINT UNSIGNED NOT NULL AUTO_INCREMENT;

SET @id_config := (SELECT id_config FROM tconfig WHERE `token` = 'metaconsole_node_id' AND `value` IS NOT NULL ORDER BY id_config DESC LIMIT 1);
DELETE FROM tconfig WHERE `token` = 'metaconsole_node_id' AND (id_config < @id_config OR `value` IS NULL);

ALTER TABLE `tpolicies` ADD COLUMN `apply_to_secondary_groups` TINYINT NOT NULL DEFAULT 0;

INSERT INTO `talert_commands` (`name`, `command`, `description`, `internal`, `fields_descriptions`, `fields_values`) VALUES ('Send&#x20;report&#x20;by&#x20;e-mail','Internal&#x20;type','This&#x20;command&#x20;allows&#x20;you&#x20;to&#x20;send&#x20;a&#x20;report&#x20;by&#x20;email.',1,'[\"Report\",\"e-mail&#x20;address\",\"Subject\",\"Text\",\"Report&#x20;type\",\"\",\"\",\"\",\"\",\"\"]','[\"_reports_\",\"\",\"\",\"_html_editor_\",\"xml,XML;pdf,PDF;json,JSON;csv,CSV\",\"\",\"\",\"\",\"\",\"\"]');
SET @send_report_command_id := LAST_INSERT_ID();
INSERT INTO `talert_actions` (`name`, `id_alert_command`, `field1`, `field2`, `field3`, `field4`, `field5`, `field6`, `field7`, `field8`, `field9`, `field10`, `id_group`, `action_threshold`, `field1_recovery`, `field2_recovery`, `field3_recovery`, `field4_recovery`, `field5_recovery`, `field6_recovery`, `field7_recovery`, `field8_recovery`, `field9_recovery`, `field10_recovery`) VALUES ('Send&#x20;Report&#x20;by&#x20;e-mail',@send_report_command_id,'','yourmail@domain.es','','&lt;div&#x20;style=&quot;background-color:&#x20;#eaf0f6;&#x20;font-family:&#x20;Arial,&#x20;Helvetica,&#x20;sans-serif;&#x20;padding:&#x20;30px;&#x20;margin:&#x20;0;&quot;&gt;&lt;table&#x20;style=&quot;max-width:&#x20;560px;&#x20;background-color:&#x20;white;&#x20;border-radius:&#x20;10px;&#x20;padding:&#x20;10px&#x20;20px&#x20;40px;&quot;&#x20;cellspacing=&quot;0&quot;&#x20;cellpadding=&quot;0&quot;&#x20;align=&quot;center&quot;&gt;&lt;thead&gt;&lt;tr&gt;&lt;td&#x20;style=&quot;padding:&#x20;0px&#x20;0px&#x20;5px;&quot;&gt;&lt;a&#x20;href=&quot;https://pandorafms.com/en/&quot;&#x20;target=&quot;_blank&quot;&gt;&lt;img&#x20;src=&quot;https://pandorafms.com/wp-content/uploads/2022/03/System-email-Pandora-FMS.png&quot;&#x20;width=&quot;206px&quot;&gt;&lt;/a&gt;&lt;/td&gt;&lt;td&#x20;style=&quot;padding:&#x20;0px&#x20;0px&#x20;5px;&quot;&gt;&lt;p&#x20;style=&quot;text-align:&#x20;right;&#x20;color:&#x20;#223549;&#x20;font-weight:&#x20;bold;&#x20;line-height:&#x20;36px;&#x20;padding:&#x20;0px;&#x20;font-size:&#x20;12px;&quot;&gt;Automatic&#x20;alert&#x20;system&lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&#x20;style=&quot;padding:&#x20;0px&#x20;0px&#x20;5px;&quot;&#x20;colspan=&quot;2&quot;&gt;&lt;hr&#x20;style=&quot;border:&#x20;1px&#x20;solid&#x20;#f5f5f5;&#x20;width:&#x20;100%;&#x20;margin:&#x20;0px;&quot;&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/thead&gt;&lt;tbody&gt;&lt;tr&gt;&lt;td&#x20;colspan=&quot;2&quot;&gt;&lt;img&#x20;onerror=&quot;this.style.display=&amp;quot;none&amp;quot;;&quot;&#x20;src=&quot;_statusimage_&quot;&#x20;style=&quot;display:&#x20;block;&#x20;margin-left:&#x20;auto;&#x20;margin-right:&#x20;auto;&#x20;width:&#x20;105px;&#x20;margin-top:&#x20;20px;&#x20;padding:&#x20;0px;&quot;&#x20;width=&quot;105px&quot;&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&#x20;colspan=&quot;2&quot;&gt;&lt;p&#x20;style=&quot;font-size:&#x20;24px;&#x20;text-align:&#x20;center;&#x20;color:&#x20;#223549;&#x20;padding:&#x20;0px&#x20;10%;&#x20;line-height:&#x20;34px;&#x20;margin:&#x20;20px&#x20;0px;&quot;&gt;We&#x20;have&#x20;bad&#x20;news&#x20;for&#x20;you,&#x20;something&#x20;is&#x20;on&#x20;&lt;span&#x20;style=&quot;text-transform:&#x20;uppercase;&#x20;font-weight:&#x20;800;&quot;&gt;_modulestatus_&lt;/span&gt;&#x20;status!&lt;/p&gt;&lt;div&gt;&lt;!--[if&#x20;mso]&gt;&lt;v:rect&#x20;xmlns:v=&quot;urn:schemas-microsoft-com:vml&quot;&#x20;xmlns:w=&quot;urn:schemas-microsoft-com:office:word&quot;&#x20;href=&quot;#&quot;&#x20;style=&quot;height:33px;v-text-anchor:middle;width:100px;&quot;&#x20;stroke=&quot;f&quot;&#x20;fillcolor=&quot;#D84A38&quot;&gt;&lt;w:anchorlock/&gt;&lt;center&gt;&lt;![endif]--&gt;&lt;a&#x20;style=&quot;background-color:&#x20;#223549;&#x20;border:&#x20;none;&#x20;color:&#x20;white;&#x20;padding:&#x20;15px&#x20;30px;&#x20;text-align:&#x20;center;&#x20;text-decoration:&#x20;none;&#x20;display:&#x20;block;&#x20;font-size:&#x20;16px;&#x20;margin-left:&#x20;auto;&#x20;margin-right:&#x20;auto;&#x20;border-radius:&#x20;100px;&#x20;max-width:&#x20;50%;&#x20;margin-top:&#x20;0px;&#x20;font-weight:&#x20;bold;&quot;&#x20;href=&quot;_homeurl_&quot;&gt;Go&#x20;to&#x20;Pandora&#x20;FMS&#x20;Console&lt;/a&gt;&lt;!--[if&#x20;mso]&gt;&lt;/center&gt;&lt;/v:rect&gt;&lt;![endif]--&gt;&lt;/div&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&#x20;colspan=&quot;2&quot;&gt;&lt;div&#x20;style=&quot;background-color:&#x20;#f6f6f6;&#x20;border-radius:&#x20;10px;&#x20;padding:&#x20;10px&#x20;20px;&#x20;margin-top:&#x20;40px;&quot;&gt;&lt;p&#x20;style=&quot;font-size:&#x20;18px;&#x20;line-height:&#x20;30px;&#x20;color:&#x20;#223549;&quot;&gt;Monitoring&#x20;details&lt;/p&gt;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Data:&#x20;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_data_&#x20;&lt;em&gt;&#40;_modulestatus_&#41;&lt;/em&gt;&lt;/span&gt;&lt;/p&gt;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Agent:&#x20;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_agent_&#x20;&lt;em&gt;_address_&lt;/em&gt;&lt;/span&gt;&lt;/p&gt;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Module:&#x20;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_module_&#x20;&lt;em&gt;_moduledescription_&lt;/em&gt;&lt;/span&gt;&lt;/p&gt;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Timestamp:&#x20;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_timestamp_&lt;/span&gt;&lt;/p&gt;&lt;/div&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&#x20;style=&quot;padding:&#x20;20px&#x20;0px;&quot;&#x20;colspan=&quot;2&quot;&gt;&lt;p&#x20;style=&quot;font-size:&#x20;18px;&#x20;line-height:&#x20;30px;&#x20;color:&#x20;#223549;&quot;&gt;Report&#x20;details&lt;/p&gt;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Generated:&amp;nbsp;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_report_generated_date_&lt;em&gt;&lt;br&gt;&lt;/em&gt;&lt;/span&gt;&lt;/p&gt;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Report&#x20;date:&amp;nbsp;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_report_date_&lt;em&gt;&lt;br&gt;&lt;/em&gt;&lt;/span&gt;&lt;/p&gt;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Description:&amp;nbsp;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_report_description_&lt;/span&gt;&lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/tbody&gt;&lt;/table&gt;&lt;div&#x20;style=&quot;text-align:&#x20;center;&#x20;margin-top:&#x20;10px;&quot;&gt;&lt;p&#x20;style=&quot;font-size:&#x20;12px;&#x20;text-decoration:&#x20;none;&#x20;font-weight:&#x20;400;&#x20;color:&#x20;#777;&quot;&gt;&lt;a&#x20;style=&quot;font-size:&#x20;12px;&#x20;text-decoration:&#x20;none;&#x20;font-weight:&#x20;400;&#x20;color:&#x20;#777;&quot;&#x20;href=&quot;https://pandorafms.com/en/contact/&quot;&gt;Contact&#x20;Us&lt;/a&gt;&amp;nbsp;&amp;nbsp;|&amp;nbsp;&amp;nbsp;&lt;a&#x20;style=&quot;font-size:&#x20;12px;&#x20;text-decoration:&#x20;none;&#x20;font-weight:&#x20;400;&#x20;color:&#x20;#777;&quot;&#x20;href=&quot;https://pandorafms.com/community/forums/forum/english/&quot;&gt;Support&lt;/a&gt;&amp;nbsp;&amp;nbsp;|&amp;nbsp;&amp;nbsp;&lt;a&#x20;style=&quot;font-size:&#x20;12px;&#x20;text-decoration:&#x20;none;&#x20;font-weight:&#x20;400;&#x20;color:&#x20;#777;&quot;&#x20;href=&quot;https://pandorafms.com/manual/en/start&quot;&gt;Docs&lt;/a&gt;&lt;/p&gt;&lt;/div&gt;&lt;/div&gt;','','','','','','',0,0,'','','','&lt;div&#x20;style=&quot;background-color:&#x20;#eaf0f6;&#x20;font-family:&#x20;Arial,&#x20;Helvetica,&#x20;sans-serif;&#x20;padding:&#x20;30px;&#x20;margin:&#x20;0;&quot;&gt;&#x0d;&#x0a;&lt;table&#x20;style=&quot;max-width:&#x20;560px;&#x20;background-color:&#x20;white;&#x20;border-radius:&#x20;10px;&#x20;padding:&#x20;10px&#x20;20px&#x20;40px;&quot;&#x20;cellspacing=&quot;0&quot;&#x20;cellpadding=&quot;0&quot;&#x20;align=&quot;center&quot;&gt;&#x0d;&#x0a;&lt;thead&gt;&#x0d;&#x0a;&lt;tr&gt;&#x0d;&#x0a;&lt;td&#x20;style=&quot;padding:&#x20;0px&#x20;0px&#x20;5px;&quot;&gt;&lt;a&#x20;href=&quot;https://pandorafms.com/en/&quot;&#x20;target=&quot;_blank&quot;&gt;&lt;img&#x20;src=&quot;https://pandorafms.com/wp-content/uploads/2022/03/System-email-Pandora-FMS.png&quot;&#x20;width=&quot;206px&quot;&gt;&lt;/a&gt;&lt;/td&gt;&#x0d;&#x0a;&lt;td&#x20;style=&quot;padding:&#x20;0px&#x20;0px&#x20;5px;&quot;&gt;&#x0d;&#x0a;&lt;p&#x20;style=&quot;text-align:&#x20;right;&#x20;color:&#x20;#223549;&#x20;font-weight:&#x20;bold;&#x20;line-height:&#x20;36px;&#x20;padding:&#x20;0px;&#x20;font-size:&#x20;12px;&quot;&gt;Automatic&#x20;alert&#x20;system&lt;/p&gt;&#x0d;&#x0a;&lt;/td&gt;&#x0d;&#x0a;&lt;/tr&gt;&#x0d;&#x0a;&lt;tr&gt;&#x0d;&#x0a;&lt;td&#x20;style=&quot;padding:&#x20;0px&#x20;0px&#x20;5px;&quot;&#x20;colspan=&quot;2&quot;&gt;&lt;hr&#x20;style=&quot;border:&#x20;1px&#x20;solid&#x20;#f5f5f5;&#x20;width:&#x20;100%;&#x20;margin:&#x20;0px;&quot;&gt;&lt;/td&gt;&#x0d;&#x0a;&lt;/tr&gt;&#x0d;&#x0a;&lt;/thead&gt;&#x0d;&#x0a;&lt;tbody&gt;&#x0d;&#x0a;&lt;tr&gt;&#x0d;&#x0a;&lt;td&#x20;colspan=&quot;2&quot;&gt;&lt;img&#x20;src=&quot;https://pandorafms.com/wp-content/uploads/2022/03/System-email-Good-news.png&quot;&#x20;style=&quot;display:&#x20;block;&#x20;margin-left:&#x20;auto;&#x20;margin-right:&#x20;auto;&#x20;width:&#x20;105px;&#x20;margin-top:&#x20;20px;&#x20;padding:&#x20;0px;&quot;&#x20;width=&quot;105px&quot;&gt;&lt;/td&gt;&#x0d;&#x0a;&lt;/tr&gt;&#x0d;&#x0a;&lt;tr&gt;&#x0d;&#x0a;&lt;td&#x20;colspan=&quot;2&quot;&gt;&#x0d;&#x0a;&lt;p&#x20;style=&quot;font-size:&#x20;24px;&#x20;text-align:&#x20;center;&#x20;color:&#x20;#223549;&#x20;padding:&#x20;0px&#x20;10%;&#x20;line-height:&#x20;34px;&#x20;margin:&#x20;20px&#x20;0px;&quot;&gt;We&#x20;have&#x20;good&#x20;news&#x20;for&#x20;you,&#x20;alert&#x20;has&#x20;been&#x20;&lt;span&#x20;style=&quot;text-transform:&#x20;uppercase;&#x20;font-weight:&#x20;800;&quot;&gt;recovered&lt;/span&gt;&lt;/p&gt;&#x0d;&#x0a;&lt;div&gt;&lt;!--[if&#x20;mso]&gt;&lt;v:rect&#x20;xmlns:v=&quot;urn:schemas-microsoft-com:vml&quot;&#x20;xmlns:w=&quot;urn:schemas-microsoft-com:office:word&quot;&#x20;href=&quot;#&quot;&#x20;style=&quot;height:33px;v-text-anchor:middle;width:100px;&quot;&#x20;stroke=&quot;f&quot;&#x20;fillcolor=&quot;#D84A38&quot;&gt;&lt;w:anchorlock/&gt;&lt;center&gt;&lt;![endif]--&gt;&lt;a&#x20;style=&quot;background-color:&#x20;#223549;&#x20;border:&#x20;none;&#x20;color:&#x20;white;&#x20;padding:&#x20;15px&#x20;30px;&#x20;text-align:&#x20;center;&#x20;text-decoration:&#x20;none;&#x20;display:&#x20;block;&#x20;font-size:&#x20;16px;&#x20;margin-left:&#x20;auto;&#x20;margin-right:&#x20;auto;&#x20;border-radius:&#x20;100px;&#x20;max-width:&#x20;50%;&#x20;margin-top:&#x20;0px;&#x20;font-weight:&#x20;bold;&quot;&#x20;href=&quot;_homeurl_&quot;&gt;Go&#x20;to&#x20;Pandora&#x20;FMS&#x20;Console&lt;/a&gt;&lt;!--[if&#x20;mso]&gt;&lt;/center&gt;&lt;/v:rect&gt;&lt;![endif]--&gt;&lt;/div&gt;&#x0d;&#x0a;&lt;/td&gt;&#x0d;&#x0a;&lt;/tr&gt;&#x0d;&#x0a;&lt;tr&gt;&#x0d;&#x0a;&lt;td&#x20;colspan=&quot;2&quot;&gt;&#x0d;&#x0a;&lt;div&#x20;style=&quot;background-color:&#x20;#f6f6f6;&#x20;border-radius:&#x20;10px;&#x20;padding:&#x20;10px&#x20;20px;&#x20;margin-top:&#x20;40px;&quot;&gt;&#x0d;&#x0a;&lt;p&#x20;style=&quot;font-size:&#x20;18px;&#x20;line-height:&#x20;30px;&#x20;color:&#x20;#223549;&quot;&gt;Monitoring&#x20;details&lt;/p&gt;&#x0d;&#x0a;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Data:&#x20;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_data_&#x20;&lt;em&gt;&#40;_modulestatus_&#41;&lt;/em&gt;&lt;/span&gt;&lt;/p&gt;&#x0d;&#x0a;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Agent:&#x20;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_agent_&#x20;&lt;em&gt;_address_&lt;/em&gt;&lt;/span&gt;&lt;/p&gt;&#x0d;&#x0a;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Module:&#x20;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_module_&#x20;&lt;em&gt;_moduledescription_&lt;/em&gt;&lt;/span&gt;&lt;/p&gt;&#x0d;&#x0a;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Timestamp:&#x20;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_timestamp_&lt;/span&gt;&lt;/p&gt;&#x0d;&#x0a;&lt;/div&gt;&#x0d;&#x0a;&lt;/td&gt;&#x0d;&#x0a;&lt;/tr&gt;&#x0d;&#x0a;&lt;tr&gt;&#x0d;&#x0a;&lt;td&#x20;style=&quot;padding:&#x20;20px&#x20;0px;&quot;&#x20;colspan=&quot;2&quot;&gt;&#x0d;&#x0a;&lt;p&#x20;style=&quot;font-size:&#x20;18px;&#x20;line-height:&#x20;30px;&#x20;color:&#x20;#223549;&quot;&gt;Report&#x20;details&lt;/p&gt;&#x0d;&#x0a;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Generated:&amp;nbsp;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_report_generated_date_&lt;em&gt;&lt;br&gt;&lt;/em&gt;&lt;/span&gt;&lt;/p&gt;&#x0d;&#x0a;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Report&#x20;date:&amp;nbsp;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_report_date_&lt;em&gt;&lt;br&gt;&lt;/em&gt;&lt;/span&gt;&lt;/p&gt;&#x0d;&#x0a;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Description:&amp;nbsp;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_report_description_&lt;/span&gt;&lt;/p&gt;&#x0d;&#x0a;&lt;/td&gt;&#x0d;&#x0a;&lt;/tr&gt;&#x0d;&#x0a;&lt;/tbody&gt;&#x0d;&#x0a;&lt;/table&gt;&#x0d;&#x0a;&lt;div&#x20;style=&quot;text-align:&#x20;center;&#x20;margin-top:&#x20;10px;&quot;&gt;&#x0d;&#x0a;&lt;p&#x20;style=&quot;font-size:&#x20;12px;&#x20;text-decoration:&#x20;none;&#x20;font-weight:&#x20;400;&#x20;color:&#x20;#777;&quot;&gt;&lt;a&#x20;style=&quot;font-size:&#x20;12px;&#x20;text-decoration:&#x20;none;&#x20;font-weight:&#x20;400;&#x20;color:&#x20;#777;&quot;&#x20;href=&quot;https://pandorafms.com/en/contact/&quot;&gt;Contact&#x20;Us&lt;/a&gt;&amp;nbsp;&amp;nbsp;|&amp;nbsp;&amp;nbsp;&lt;a&#x20;style=&quot;font-size:&#x20;12px;&#x20;text-decoration:&#x20;none;&#x20;font-weight:&#x20;400;&#x20;color:&#x20;#777;&quot;&#x20;href=&quot;https://pandorafms.com/community/forums/forum/english/&quot;&gt;Support&lt;/a&gt;&amp;nbsp;&amp;nbsp;|&amp;nbsp;&amp;nbsp;&lt;a&#x20;style=&quot;font-size:&#x20;12px;&#x20;text-decoration:&#x20;none;&#x20;font-weight:&#x20;400;&#x20;color:&#x20;#777;&quot;&#x20;href=&quot;https://pandorafms.com/manual/en/start&quot;&gt;Docs&lt;/a&gt;&lt;/p&gt;&#x0d;&#x0a;&lt;/div&gt;&#x0d;&#x0a;&lt;/div&gt;','','','','','','');

INSERT INTO `talert_commands` (`name`, `command`, `description`, `internal`, `fields_descriptions`, `fields_values`) VALUES ('Send&#x20;report&#x20;by&#x20;e-mail&#x20;(from&#x20;template)','Internal&#x20;type','This&#x20;command&#x20;allows&#x20;you&#x20;to&#x20;send&#x20;a&#x20;report&#x20;generated&#x20;from&#x20;a&#x20;template&#x20;by&#x20;email.',1,'[\"Template\",\"Regexp&#x20;agent&#x20;filter\",\"e-mail&#x20;address\",\"Subject\",\"Text\",\"Report&#x20;type\",\"\",\"\",\"\",\"\"]','[\"_report_templates_\",\"\",\"\",\"\",\"_html_editor_\",\"xml,XML;pdf,PDF;json,JSON;csv,CSV\",\"\",\"\",\"\",\"\"]');
SET @send_report_by_temp_command_id := LAST_INSERT_ID();
INSERT INTO `talert_actions` (`name`, `id_alert_command`, `field1`, `field2`, `field3`, `field4`, `field5`, `field6`, `field7`, `field8`, `field9`, `field10`, `id_group`, `action_threshold`, `field1_recovery`, `field2_recovery`, `field3_recovery`, `field4_recovery`, `field5_recovery`, `field6_recovery`, `field7_recovery`, `field8_recovery`, `field9_recovery`, `field10_recovery`) VALUES ('Send&#x20;Report&#x20;by&#x20;e-mail&#x20;(from&#x20;template)',@send_report_by_temp_command_id,'','','yourmail@domain.es','','&lt;div&#x20;style=&quot;background-color:&#x20;#eaf0f6;&#x20;font-family:&#x20;Arial,&#x20;Helvetica,&#x20;sans-serif;&#x20;padding:&#x20;30px;&#x20;margin:&#x20;0;&quot;&gt;&lt;table&#x20;style=&quot;max-width:&#x20;560px;&#x20;background-color:&#x20;white;&#x20;border-radius:&#x20;10px;&#x20;padding:&#x20;10px&#x20;20px&#x20;40px;&quot;&#x20;cellspacing=&quot;0&quot;&#x20;cellpadding=&quot;0&quot;&#x20;align=&quot;center&quot;&gt;&lt;thead&gt;&lt;tr&gt;&lt;td&#x20;style=&quot;padding:&#x20;0px&#x20;0px&#x20;5px;&quot;&gt;&lt;a&#x20;href=&quot;https://pandorafms.com/en/&quot;&#x20;target=&quot;_blank&quot;&gt;&lt;img&#x20;src=&quot;https://pandorafms.com/wp-content/uploads/2022/03/System-email-Pandora-FMS.png&quot;&#x20;width=&quot;206px&quot;&gt;&lt;/a&gt;&lt;/td&gt;&lt;td&#x20;style=&quot;padding:&#x20;0px&#x20;0px&#x20;5px;&quot;&gt;&lt;p&#x20;style=&quot;text-align:&#x20;right;&#x20;color:&#x20;#223549;&#x20;font-weight:&#x20;bold;&#x20;line-height:&#x20;36px;&#x20;padding:&#x20;0px;&#x20;font-size:&#x20;12px;&quot;&gt;Automatic&#x20;alert&#x20;system&lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&#x20;style=&quot;padding:&#x20;0px&#x20;0px&#x20;5px;&quot;&#x20;colspan=&quot;2&quot;&gt;&lt;hr&#x20;style=&quot;border:&#x20;1px&#x20;solid&#x20;#f5f5f5;&#x20;width:&#x20;100%;&#x20;margin:&#x20;0px;&quot;&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/thead&gt;&lt;tbody&gt;&lt;tr&gt;&lt;td&#x20;colspan=&quot;2&quot;&gt;&lt;img&#x20;onerror=&quot;this.style.display=&amp;quot;none&amp;quot;;&quot;&#x20;src=&quot;_statusimage_&quot;&#x20;style=&quot;display:&#x20;block;&#x20;margin-left:&#x20;auto;&#x20;margin-right:&#x20;auto;&#x20;width:&#x20;105px;&#x20;margin-top:&#x20;20px;&#x20;padding:&#x20;0px;&quot;&#x20;width=&quot;105px&quot;&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&#x20;colspan=&quot;2&quot;&gt;&lt;p&#x20;style=&quot;font-size:&#x20;24px;&#x20;text-align:&#x20;center;&#x20;color:&#x20;#223549;&#x20;padding:&#x20;0px&#x20;10%;&#x20;line-height:&#x20;34px;&#x20;margin:&#x20;20px&#x20;0px;&quot;&gt;We&#x20;have&#x20;bad&#x20;news&#x20;for&#x20;you,&#x20;something&#x20;is&#x20;on&#x20;&lt;span&#x20;style=&quot;text-transform:&#x20;uppercase;&#x20;font-weight:&#x20;800;&quot;&gt;_modulestatus_&lt;/span&gt;&#x20;status!&lt;/p&gt;&lt;div&gt;&lt;!--[if&#x20;mso]&gt;&lt;v:rect&#x20;xmlns:v=&quot;urn:schemas-microsoft-com:vml&quot;&#x20;xmlns:w=&quot;urn:schemas-microsoft-com:office:word&quot;&#x20;href=&quot;#&quot;&#x20;style=&quot;height:33px;v-text-anchor:middle;width:100px;&quot;&#x20;stroke=&quot;f&quot;&#x20;fillcolor=&quot;#D84A38&quot;&gt;&lt;w:anchorlock/&gt;&lt;center&gt;&lt;![endif]--&gt;&lt;a&#x20;style=&quot;background-color:&#x20;#223549;&#x20;border:&#x20;none;&#x20;color:&#x20;white;&#x20;padding:&#x20;15px&#x20;30px;&#x20;text-align:&#x20;center;&#x20;text-decoration:&#x20;none;&#x20;display:&#x20;block;&#x20;font-size:&#x20;16px;&#x20;margin-left:&#x20;auto;&#x20;margin-right:&#x20;auto;&#x20;border-radius:&#x20;100px;&#x20;max-width:&#x20;50%;&#x20;margin-top:&#x20;0px;&#x20;font-weight:&#x20;bold;&quot;&#x20;href=&quot;_homeurl_&quot;&gt;Go&#x20;to&#x20;Pandora&#x20;FMS&#x20;Console&lt;/a&gt;&lt;!--[if&#x20;mso]&gt;&lt;/center&gt;&lt;/v:rect&gt;&lt;![endif]--&gt;&lt;/div&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&#x20;colspan=&quot;2&quot;&gt;&lt;div&#x20;style=&quot;background-color:&#x20;#f6f6f6;&#x20;border-radius:&#x20;10px;&#x20;padding:&#x20;10px&#x20;20px;&#x20;margin-top:&#x20;40px;&quot;&gt;&lt;p&#x20;style=&quot;font-size:&#x20;18px;&#x20;line-height:&#x20;30px;&#x20;color:&#x20;#223549;&quot;&gt;Monitoring&#x20;details&lt;/p&gt;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Data:&#x20;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_data_&#x20;&lt;em&gt;&#40;_modulestatus_&#41;&lt;/em&gt;&lt;/span&gt;&lt;/p&gt;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Agent:&#x20;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_agent_&#x20;&lt;em&gt;_address_&lt;/em&gt;&lt;/span&gt;&lt;/p&gt;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Module:&#x20;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_module_&#x20;&lt;em&gt;_moduledescription_&lt;/em&gt;&lt;/span&gt;&lt;/p&gt;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Timestamp:&#x20;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_timestamp_&lt;/span&gt;&lt;/p&gt;&lt;/div&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&#x20;style=&quot;padding:&#x20;20px&#x20;0px;&quot;&#x20;colspan=&quot;2&quot;&gt;&lt;p&#x20;style=&quot;font-size:&#x20;18px;&#x20;line-height:&#x20;30px;&#x20;color:&#x20;#223549;&quot;&gt;Report&#x20;details&lt;/p&gt;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Generated:&amp;nbsp;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_report_generated_date_&lt;em&gt;&lt;br&gt;&lt;/em&gt;&lt;/span&gt;&lt;/p&gt;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Report&#x20;date:&amp;nbsp;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_report_date_&lt;em&gt;&lt;br&gt;&lt;/em&gt;&lt;/span&gt;&lt;/p&gt;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Description:&amp;nbsp;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_report_description_&lt;/span&gt;&lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/tbody&gt;&lt;/table&gt;&lt;div&#x20;style=&quot;text-align:&#x20;center;&#x20;margin-top:&#x20;10px;&quot;&gt;&lt;p&#x20;style=&quot;font-size:&#x20;12px;&#x20;text-decoration:&#x20;none;&#x20;font-weight:&#x20;400;&#x20;color:&#x20;#777;&quot;&gt;&lt;a&#x20;style=&quot;font-size:&#x20;12px;&#x20;text-decoration:&#x20;none;&#x20;font-weight:&#x20;400;&#x20;color:&#x20;#777;&quot;&#x20;href=&quot;https://pandorafms.com/en/contact/&quot;&gt;Contact&#x20;Us&lt;/a&gt;&amp;nbsp;&amp;nbsp;|&amp;nbsp;&amp;nbsp;&lt;a&#x20;style=&quot;font-size:&#x20;12px;&#x20;text-decoration:&#x20;none;&#x20;font-weight:&#x20;400;&#x20;color:&#x20;#777;&quot;&#x20;href=&quot;https://pandorafms.com/community/forums/forum/english/&quot;&gt;Support&lt;/a&gt;&amp;nbsp;&amp;nbsp;|&amp;nbsp;&amp;nbsp;&lt;a&#x20;style=&quot;font-size:&#x20;12px;&#x20;text-decoration:&#x20;none;&#x20;font-weight:&#x20;400;&#x20;color:&#x20;#777;&quot;&#x20;href=&quot;https://pandorafms.com/manual/en/start&quot;&gt;Docs&lt;/a&gt;&lt;/p&gt;&lt;/div&gt;&lt;/div&gt;','','','','','',0,0,'','','','','&lt;div&#x20;style=&quot;background-color:&#x20;#eaf0f6;&#x20;font-family:&#x20;Arial,&#x20;Helvetica,&#x20;sans-serif;&#x20;padding:&#x20;30px;&#x20;margin:&#x20;0;&quot;&gt;&#x0d;&#x0a;&lt;table&#x20;style=&quot;max-width:&#x20;560px;&#x20;background-color:&#x20;white;&#x20;border-radius:&#x20;10px;&#x20;padding:&#x20;10px&#x20;20px&#x20;40px;&quot;&#x20;cellspacing=&quot;0&quot;&#x20;cellpadding=&quot;0&quot;&#x20;align=&quot;center&quot;&gt;&#x0d;&#x0a;&lt;thead&gt;&#x0d;&#x0a;&lt;tr&gt;&#x0d;&#x0a;&lt;td&#x20;style=&quot;padding:&#x20;0px&#x20;0px&#x20;5px;&quot;&gt;&lt;a&#x20;href=&quot;https://pandorafms.com/en/&quot;&#x20;target=&quot;_blank&quot;&gt;&lt;img&#x20;src=&quot;https://pandorafms.com/wp-content/uploads/2022/03/System-email-Pandora-FMS.png&quot;&#x20;width=&quot;206px&quot;&gt;&lt;/a&gt;&lt;/td&gt;&#x0d;&#x0a;&lt;td&#x20;style=&quot;padding:&#x20;0px&#x20;0px&#x20;5px;&quot;&gt;&#x0d;&#x0a;&lt;p&#x20;style=&quot;text-align:&#x20;right;&#x20;color:&#x20;#223549;&#x20;font-weight:&#x20;bold;&#x20;line-height:&#x20;36px;&#x20;padding:&#x20;0px;&#x20;font-size:&#x20;12px;&quot;&gt;Automatic&#x20;alert&#x20;system&lt;/p&gt;&#x0d;&#x0a;&lt;/td&gt;&#x0d;&#x0a;&lt;/tr&gt;&#x0d;&#x0a;&lt;tr&gt;&#x0d;&#x0a;&lt;td&#x20;style=&quot;padding:&#x20;0px&#x20;0px&#x20;5px;&quot;&#x20;colspan=&quot;2&quot;&gt;&lt;hr&#x20;style=&quot;border:&#x20;1px&#x20;solid&#x20;#f5f5f5;&#x20;width:&#x20;100%;&#x20;margin:&#x20;0px;&quot;&gt;&lt;/td&gt;&#x0d;&#x0a;&lt;/tr&gt;&#x0d;&#x0a;&lt;/thead&gt;&#x0d;&#x0a;&lt;tbody&gt;&#x0d;&#x0a;&lt;tr&gt;&#x0d;&#x0a;&lt;td&#x20;colspan=&quot;2&quot;&gt;&lt;img&#x20;src=&quot;https://pandorafms.com/wp-content/uploads/2022/03/System-email-Good-news.png&quot;&#x20;style=&quot;display:&#x20;block;&#x20;margin-left:&#x20;auto;&#x20;margin-right:&#x20;auto;&#x20;width:&#x20;105px;&#x20;margin-top:&#x20;20px;&#x20;padding:&#x20;0px;&quot;&#x20;width=&quot;105px&quot;&gt;&lt;/td&gt;&#x0d;&#x0a;&lt;/tr&gt;&#x0d;&#x0a;&lt;tr&gt;&#x0d;&#x0a;&lt;td&#x20;colspan=&quot;2&quot;&gt;&#x0d;&#x0a;&lt;p&#x20;style=&quot;font-size:&#x20;24px;&#x20;text-align:&#x20;center;&#x20;color:&#x20;#223549;&#x20;padding:&#x20;0px&#x20;10%;&#x20;line-height:&#x20;34px;&#x20;margin:&#x20;20px&#x20;0px;&quot;&gt;We&#x20;have&#x20;good&#x20;news&#x20;for&#x20;you,&#x20;alert&#x20;has&#x20;been&#x20;&lt;span&#x20;style=&quot;text-transform:&#x20;uppercase;&#x20;font-weight:&#x20;800;&quot;&gt;recovered&lt;/span&gt;&lt;/p&gt;&#x0d;&#x0a;&lt;div&gt;&lt;!--[if&#x20;mso]&gt;&lt;v:rect&#x20;xmlns:v=&quot;urn:schemas-microsoft-com:vml&quot;&#x20;xmlns:w=&quot;urn:schemas-microsoft-com:office:word&quot;&#x20;href=&quot;#&quot;&#x20;style=&quot;height:33px;v-text-anchor:middle;width:100px;&quot;&#x20;stroke=&quot;f&quot;&#x20;fillcolor=&quot;#D84A38&quot;&gt;&lt;w:anchorlock/&gt;&lt;center&gt;&lt;![endif]--&gt;&lt;a&#x20;style=&quot;background-color:&#x20;#223549;&#x20;border:&#x20;none;&#x20;color:&#x20;white;&#x20;padding:&#x20;15px&#x20;30px;&#x20;text-align:&#x20;center;&#x20;text-decoration:&#x20;none;&#x20;display:&#x20;block;&#x20;font-size:&#x20;16px;&#x20;margin-left:&#x20;auto;&#x20;margin-right:&#x20;auto;&#x20;border-radius:&#x20;100px;&#x20;max-width:&#x20;50%;&#x20;margin-top:&#x20;0px;&#x20;font-weight:&#x20;bold;&quot;&#x20;href=&quot;_homeurl_&quot;&gt;Go&#x20;to&#x20;Pandora&#x20;FMS&#x20;Console&lt;/a&gt;&lt;!--[if&#x20;mso]&gt;&lt;/center&gt;&lt;/v:rect&gt;&lt;![endif]--&gt;&lt;/div&gt;&#x0d;&#x0a;&lt;/td&gt;&#x0d;&#x0a;&lt;/tr&gt;&#x0d;&#x0a;&lt;tr&gt;&#x0d;&#x0a;&lt;td&#x20;colspan=&quot;2&quot;&gt;&#x0d;&#x0a;&lt;div&#x20;style=&quot;background-color:&#x20;#f6f6f6;&#x20;border-radius:&#x20;10px;&#x20;padding:&#x20;10px&#x20;20px;&#x20;margin-top:&#x20;40px;&quot;&gt;&#x0d;&#x0a;&lt;p&#x20;style=&quot;font-size:&#x20;18px;&#x20;line-height:&#x20;30px;&#x20;color:&#x20;#223549;&quot;&gt;Monitoring&#x20;details&lt;/p&gt;&#x0d;&#x0a;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Data:&#x20;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_data_&#x20;&lt;em&gt;&#40;_modulestatus_&#41;&lt;/em&gt;&lt;/span&gt;&lt;/p&gt;&#x0d;&#x0a;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Agent:&#x20;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_agent_&#x20;&lt;em&gt;_address_&lt;/em&gt;&lt;/span&gt;&lt;/p&gt;&#x0d;&#x0a;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Module:&#x20;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_module_&#x20;&lt;em&gt;_moduledescription_&lt;/em&gt;&lt;/span&gt;&lt;/p&gt;&#x0d;&#x0a;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Timestamp:&#x20;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_timestamp_&lt;/span&gt;&lt;/p&gt;&#x0d;&#x0a;&lt;/div&gt;&#x0d;&#x0a;&lt;/td&gt;&#x0d;&#x0a;&lt;/tr&gt;&#x0d;&#x0a;&lt;tr&gt;&#x0d;&#x0a;&lt;td&#x20;style=&quot;padding:&#x20;20px&#x20;0px;&quot;&#x20;colspan=&quot;2&quot;&gt;&#x0d;&#x0a;&lt;p&#x20;style=&quot;font-size:&#x20;18px;&#x20;line-height:&#x20;30px;&#x20;color:&#x20;#223549;&quot;&gt;Report&#x20;details&lt;/p&gt;&#x0d;&#x0a;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Generated:&amp;nbsp;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_report_generated_date_&lt;em&gt;&lt;br&gt;&lt;/em&gt;&lt;/span&gt;&lt;/p&gt;&#x0d;&#x0a;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Report&#x20;date:&amp;nbsp;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_report_date_&lt;em&gt;&lt;br&gt;&lt;/em&gt;&lt;/span&gt;&lt;/p&gt;&#x0d;&#x0a;&lt;p&#x20;style=&quot;font-size:&#x20;15px;&#x20;color:&#x20;#333333;&#x20;font-weight:&#x20;800;&#x20;line-height:&#x20;15px;&quot;&gt;Description:&amp;nbsp;&lt;span&#x20;style=&quot;font-weight:&#x20;400!important;&quot;&gt;_report_description_&lt;/span&gt;&lt;/p&gt;&#x0d;&#x0a;&lt;/td&gt;&#x0d;&#x0a;&lt;/tr&gt;&#x0d;&#x0a;&lt;/tbody&gt;&#x0d;&#x0a;&lt;/table&gt;&#x0d;&#x0a;&lt;div&#x20;style=&quot;text-align:&#x20;center;&#x20;margin-top:&#x20;10px;&quot;&gt;&#x0d;&#x0a;&lt;p&#x20;style=&quot;font-size:&#x20;12px;&#x20;text-decoration:&#x20;none;&#x20;font-weight:&#x20;400;&#x20;color:&#x20;#777;&quot;&gt;&lt;a&#x20;style=&quot;font-size:&#x20;12px;&#x20;text-decoration:&#x20;none;&#x20;font-weight:&#x20;400;&#x20;color:&#x20;#777;&quot;&#x20;href=&quot;https://pandorafms.com/en/contact/&quot;&gt;Contact&#x20;Us&lt;/a&gt;&amp;nbsp;&amp;nbsp;|&amp;nbsp;&amp;nbsp;&lt;a&#x20;style=&quot;font-size:&#x20;12px;&#x20;text-decoration:&#x20;none;&#x20;font-weight:&#x20;400;&#x20;color:&#x20;#777;&quot;&#x20;href=&quot;https://pandorafms.com/community/forums/forum/english/&quot;&gt;Support&lt;/a&gt;&amp;nbsp;&amp;nbsp;|&amp;nbsp;&amp;nbsp;&lt;a&#x20;style=&quot;font-size:&#x20;12px;&#x20;text-decoration:&#x20;none;&#x20;font-weight:&#x20;400;&#x20;color:&#x20;#777;&quot;&#x20;href=&quot;https://pandorafms.com/manual/en/start&quot;&gt;Docs&lt;/a&gt;&lt;/p&gt;&#x0d;&#x0a;&lt;/div&gt;&#x0d;&#x0a;&lt;/div&gt;','','','','','');

UPDATE `tplugin` set `no_delete` = 1 WHERE `name` IN ('IPMI&#x20;Plugin', 'DNS&#x20;Plugin', 'UDP&#x20;port&#x20;check', 'SMTP&#x20;Check', 'MySQL&#x20;Plugin', 'SNMP&#x20;remote', 'Packet&#x20;Loss', 'Wizard&#x20;SNMP&#x20;module', 'Wizard&#x20;SNMP&#x20;process', 'Wizard&#x20;WMI&#x20;module', 'Network&#x20;bandwidth&#x20;SNMP');

COMMIT;
